open Pretty
open Testtype
open Testtype_print

class myVisitor : testtypeVisitor = object
  inherit nopTesttypeVisitor
  method v_myint (x : myint) = ChangeTo(match x with Int(y) -> Int(y+1))
end 

let main () = begin
  let mi i = (Int(i)) in 
  let mybar = { x = mi 5; y = "hello" ; z = That (mi 999,mi 888) ; } in
  let myfred = (Some([ mi 1 ; mi 2 ; mi 99 ; mi 98 ])) in 
  let mydoc = dprintf "Mybar is @[%a@], myfred is @[%a@]\n" 
    d_bar mybar 
    d_fred myfred
    in
  fprint stdout 80 mydoc ;

  let vis = new myVisitor in 

  let newbar = visit_bar vis mybar in 
  let newfred = visit_fred vis myfred in 
  let mydoc = dprintf "Newbar is @[%a@], newfred is @[%a@]\n" 
    d_bar newbar 
    d_fred newfred in
  fprint stdout 80 mydoc 


end ;;

main () ;;
